/**
 * Created by will on 10/1/15.
 */
var express = require('express');
var session = require('express-session');
var timeout = require('connect-timeout');
var MSSQLStore = require('connect-mssql')(session);
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');
var path = require('path');

var env = process.env.NODE_ENV || "prod";
var config = require('./config.json')[env];
var favicon = require('serve-favicon');

module.exports = function(app, passport) {
    app.use(express.static(path.join(__dirname, '..', '/public')));
    app.use(favicon(path.join(__dirname, '..', '/public/assets/images/favicon.png')));

    app.set('views', path.join(__dirname, '../..', '/views'));
    app.set('view engine', 'jade');

    app.use(bodyParser.json());
    app.use(cookieParser());

    app.use(timeout(120000));
    app.use(haltOnTimedOut);

    function haltOnTimedOut(req, res, next) {
        if (!req.timedout) next();
    }

    var sqlConfig = {
        user: config.username,
        password: config.password,
        database: config.database,
        server: config.host
    };

    var options = {
        table: 'tbl_sessions'
    };

    var sessionOpts = {
        resave: false,
        saveUninitialized: false,
        store: new MSSQLStore(sqlConfig, options),
        secret: "130q34-0zsvd09ad"
    };

    app.use(session(sessionOpts));

    app.use(passport.initialize());
    app.use(passport.session());
};
