module.exports = function(app, models, type) {

    if (type == 'count') {
        createManyCounts();
    } else if (type == 'inventory') {
        createManyInventory();
    } else if (type == 'both') {
        createManyCounts();
        createManyInventory();
    }

    function createManyInventory() {
        var records = [];

        for (var i = 0; i < 10000; i++) {
            var inventory = {};

            inventory.clinicId = '9999';
            inventory.count = getRandomInt(0, 50);
            inventory.countType = getRandomCountType();
            inventory.description = getRandomDescription();
            inventory.sapMaterial = getRandomSapMaterial();
            inventory.timestamp = randomDate(new Date(2015, 0, 1), new Date()).toString();
            inventory.vendorMaterial = getRandomVendorMaterial();
            inventory.type = getRandomType();
            inventory.userId = '9999';
            inventory.poPrefix = getRandomPoPrefix();
            inventory.poNumber = getRandomPoNumber();
            inventory.lot = getRandomLot();
            inventory.expiration = randomDate(new Date(2018, 12, 31), new Date(2016, 6, 6)).toString();

            records.push(inventory);
            if (i % 1000 == 0) {
                models.Inventory.bulkCreate(records).done(function (data) {
                    console.log("done!");
                });
                console.log("bulkcreating, " + i);
                records = [];
            }
        }
    }


    function createManyCounts() {
        var counts = [];

        for (var i = 0; i < 10000; i++) {
            var count = {};

            count.catType = getRandomCountType();
            count.clinicId = '9999';
            count.cntInd = true;
            count.count = getRandomInt(0, 50);
            count.countType = count.catType;
            count.dateModified = randomDate(new Date(2015, 0, 1), new Date()).toString();
            count.description = getRandomDescription();
            count.deviceId = getRandomDeviceId();
            count.devicePk = getRandomInt(1, 250);
            count.sapMaterial = getRandomSapMaterial();
            count.timestamp = randomDate(new Date(2015, 0, 1), new Date()).toString();
            count.vendorMaterial = getRandomVendorMaterial();

            counts.push(count);
            if (i % 1000 == 0) {
                models.CountData.bulkCreate(counts).done(function (data) {
                    console.log("done!");
                });
                console.log("bulkcreating, " + i);
                counts = [];
            }

        }
    }

};



function getRandomType() {
    var rand = getRandomInt(0, 2);
    switch (rand) {
        case 0:
            return 'Inventory';
        case 1:
            return 'Consumption';
        case 2:
            return 'Receipt';
    }
}

function getRandomPoPrefix() {
    return "" + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9)
        + getRandomInt(0, 9);
}
function getRandomPoNumber() {
    return "" + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9)
        + getRandomInt(0, 9);
}

function getRandomLot() {
    return "0" + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9)
        + getRandomInt(0, 9) + getRandomInt(0, 9);

}

function getRandomSapMaterial() {
    var string = [
        "5000", getRandomInt(0, 9).toString(), getRandomInt(0, 9).toString(), getRandomInt(0, 9).toString(),
        getRandomInt(0, 9).toString(), getRandomInt(0, 9).toString(), getRandomInt(0, 9).toString()
    ];
    return string.join("");
}

function getRandomVendorMaterial() {
    return "" + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9)
        + getRandomInt(0, 9) + getRandomInt(0, 9);
}

function getRandomDeviceId() {
    return "" + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + "-"
        + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + "-"
        + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + "-"
        + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9) + getRandomInt(0, 9);
}

function getRandomDescription() {
    var strings = ["ACETAMIMOPHEN 325MG",
        "ACETAMIN 500 MG CPL 100",
        "ACETAMINOPHEN 325MG TAB 100 UD",
        "ACETAMINOPHEN 325MG TAB 1000",
        "ACTIVASE CATHFLO 2MG VIAL",
        "ADENOCARD 3MG/ML SYG 2ML",
        "ALUM HYD 16OZ GEL",
        "AMIKACIN SUL 10X2ML  250MG/ML SDV",
        "AMIKACIN SUL 250MG/ML SDV 2ML 10",
        "Amphotericin B 50mg pwd",
        "AMPICILLIN 1GM VL 10",
        "AMPICILLIN 2GM VL 10/PK",
        "APLISOL 1ML  5TU10TESTVL",
        "BACITR 500 UN/GM ONT 144X.9 GM",
        "CAL CHL ANS 10% SYG 10X10ML",
        "DEFEROXAMINE 500MG VL 4",
        "ENGERIX - B 20MCG/M PFS 10X1ML",
        "FEOSOL COMPLETE CAPLET 30",
        "GELFOAM 1212-7MM    SPG",
        "HECTOROL      0.5MCG    CAP          50",
        "IBUPROFEN 200MG TAB 100",
        "LEVOFLOXACIN 25MG/ML VL 20ML",
        "MAG SUL 25X2ML   50%     SDV",
        "Naloxone .4mg/ml ftv 1ml 10bx",
        "ODANSETRON 4MG SDV 25X2ML",
        "PAIN EASE 3.5OZ SPRAY",
        "RECOMBIVAX 10MCG/ML VL 1ML",
        "SOD BIC 25X50ML  8.4%     FTV",
        "TAZICEF 1GM 20ML VIAL 25/",
        "VANCOMYCIN 10   1GM F/TFTV",
        "Water Bact ftv 30ml x 25",
        "XYLOCAINE 100MG AMP 10X5ML",
        "ZEMPLAR 10 MCG MDV 25X1ML"];

    return strings[getRandomInt(0, strings.length)];
}

function randomDate(start, end) {
    return new Date(start.getTime() + Math.random() * (end.getTime() - start.getTime()));
}

function getRandomCountType() {
    var random = Math.random();
    if (random <= .33) {
        return 'ESA';
    } else if (random > .33 && random <= .66) {
        return 'Other';
    } else {
        return '';
    }
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min)) + min;
}

