/**
 * Created by John on 1/4/2017.
 */
"use strict";

var moment = require('moment');
var winston = require('winston');
var logger = winston.loggers.get('default');
var VendorList = require("./vendorList");
var MasterItem = require("./masterItem");

module.exports = function(sequelize, DataTypes) {
    var ItemCatalog = sequelize.define('ItemCatalog', {
            id: {
                type: DataTypes.INTEGER,
                field: 'id',
                primaryKey: true,
                autoIncrement: true
            },
            itemId: {
                type: DataTypes.INTEGER,
                field: 'item_id',
                references: {
                    // This is a reference to another model
                    model: MasterItem,

                    // This is the column name of the referenced model
                    key: 'id'
                }
            },
            vendorId: {
                type: DataTypes.INTEGER,
                field: 'vendor_id',
                references: {
                    // This is a reference to another model
                    model: VendorList,

                    // This is the column name of the referenced model
                    key: 'id'
                }
            }
        },
        {
            timestamps: false,
            tableName: 'tbl_item_catalog',
            indexes: [
                // Create a unique index on device timestamp
                {
                    unique: true,
                    fields: ['itemId', 'vendorId']
                },
            ]
        }
    );
    return ItemCatalog;
};