"use strict";

module.exports = function(sequelize, DataTypes) {
    var User = sequelize.define('User', {
            id: {
                type: DataTypes.INTEGER,
                field: 'id',
                primaryKey: true,
                autoIncrement: true
            },
            username: {
                type: DataTypes.STRING,
                field: 'username'
            },
            password: {
                type: DataTypes.STRING,
                field: 'password'
            },
            type: {
                type: DataTypes.INTEGER,
                field: 'type'
            },
            displayName: {
                type: DataTypes.STRING,
                field: 'display_name'
            },
            isActive: {
                type: new DataTypes.VIRTUAL(DataTypes.BOOLEAN, ['type']),
                get: function () {
                    return (this.get('type') && (this.get('type') > 0));
                }
            },
            isAdmin: {
                type: new DataTypes.VIRTUAL(DataTypes.BOOLEAN, ['type']),
                get: function () {
                    return (this.get('type') && this.get('type') == 2);
                }
            }
        },
        {
            timestamps: false,
            tableName: 'tbl_user'
        }
    );
    return User;
};
